/*****************************************************************************
 * @file:    startup_LPC8N04.c
 * @purpose: CMSIS Cortex-M0 Core Device Startup File for the
 *           LPC8N04
 * @version: 1.0
 * @date:    2018-6-21
 *
 * The Clear BSD License
 * Copyright 1997-2016 Freescale Semiconductor, Inc.
 * Copyright 2016-2018 NXP
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted (subject to the limitations in the
 * disclaimer below) provided that the following conditions are met:
 *
 * * Redistributions of source code must retain the above copyright
 *   notice, this list of conditions and the following disclaimer.
 *
 * * Redistributions in binary form must reproduce the above copyright
 *   notice, this list of conditions and the following disclaimer in the
 *   documentation and/or other materials provided with the distribution.
 *
 * * Neither the name of the copyright holder nor the names of its
 *   contributors may be used to endorse or promote products derived from
 *   this software without specific prior written permission.
 *
 * NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE
 * GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT
 * HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
 * BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN
 * IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/

#include "LPC8N04.h"


/*----------------------------------------------------------------------------
  Linker generated Symbols
 *----------------------------------------------------------------------------*/
extern uint32_t Image$$ARM_LIB_STACK$$ZI$$Limit;


/*----------------------------------------------------------------------------
  Exception / Interrupt Handler Function Prototype
 *----------------------------------------------------------------------------*/
typedef void( *pFunc )( void );


/*----------------------------------------------------------------------------
  External References
 *----------------------------------------------------------------------------*/
extern void __main     (void) __attribute__((noreturn)); /* PreeMain (C library entry point) */


/*----------------------------------------------------------------------------
  Internal References
 *----------------------------------------------------------------------------*/
void Default_Handler(void) __attribute__ ((noreturn));
void Reset_Handler  (void) __attribute__ ((noreturn));


/*----------------------------------------------------------------------------
  User Initial Stack & Heap
 *----------------------------------------------------------------------------*/
#define __initial_sp    Image$$ARM_LIB_STACK$$ZI$$Limit


/*----------------------------------------------------------------------------
  Exception / Interrupt Handler
 *----------------------------------------------------------------------------*/
/* Exceptions */
void NMI_Handler            (void) __attribute__ ((weak, alias("Default_Handler")));
void HardFault_Handler      (void) __attribute__ ((weak, alias("Default_Handler")));
void SVC_Handler            (void) __attribute__ ((weak, alias("Default_Handler")));
void PendSV_Handler         (void) __attribute__ ((weak, alias("Default_Handler")));
void SysTick_Handler        (void) __attribute__ ((weak, alias("Default_Handler")));

void PIO0_0_IRQHandler      (void) __attribute__ ((weak, alias("Default_Handler")));
void PIO0_1_IRQHandler      (void) __attribute__ ((weak, alias("Default_Handler")));
void PIO0_2_IRQHandler      (void) __attribute__ ((weak, alias("Default_Handler")));
void PIO0_3_IRQHandler      (void) __attribute__ ((weak, alias("Default_Handler")));
void PIO0_4_IRQHandler      (void) __attribute__ ((weak, alias("Default_Handler")));
void PIO0_5_IRQHandler      (void) __attribute__ ((weak, alias("Default_Handler")));
void PIO0_6_IRQHandler      (void) __attribute__ ((weak, alias("Default_Handler")));
void PIO0_7_IRQHandler      (void) __attribute__ ((weak, alias("Default_Handler")));
void PIO0_8_IRQHandler      (void) __attribute__ ((weak, alias("Default_Handler")));
void PIO0_9_IRQHandler      (void) __attribute__ ((weak, alias("Default_Handler")));
void PIO0_10_IRQHandler     (void) __attribute__ ((weak, alias("Default_Handler")));
void RFFIELD_IRQHandler     (void) __attribute__ ((weak, alias("Default_Handler")));
void RTCPWREQ_IRQHandler    (void) __attribute__ ((weak, alias("Default_Handler")));
void NFC_IRQHandler         (void) __attribute__ ((weak, alias("Default_Handler")));
void RTC_IRQHandler         (void) __attribute__ ((weak, alias("Default_Handler")));
void I2C0_IRQHandler        (void) __attribute__ ((weak, alias("Default_Handler")));
void CT16B0_IRQHandler      (void) __attribute__ ((weak, alias("Default_Handler")));
void PMUFLD_IRQHandler      (void) __attribute__ ((weak, alias("Default_Handler")));
void CT32B0_IRQHandler      (void) __attribute__ ((weak, alias("Default_Handler")));
void PMUBOD_IRQHandler      (void) __attribute__ ((weak, alias("Default_Handler")));
void SSP0_IRQHandler        (void) __attribute__ ((weak, alias("Default_Handler")));
void TSEN_IRQHandler        (void) __attribute__ ((weak, alias("Default_Handler")));
void C2D_IRQHandler         (void) __attribute__ ((weak, alias("Default_Handler")));
void Reserved39_IRQHandler  (void) __attribute__ ((weak, alias("Default_Handler")));
void I2D_IRQHandler         (void) __attribute__ ((weak, alias("Default_Handler")));
void ADCDAC_IRQHandler      (void) __attribute__ ((weak, alias("Default_Handler")));
void WDT_IRQHandler         (void) __attribute__ ((weak, alias("Default_Handler")));
void FLASH_IRQHandler       (void) __attribute__ ((weak, alias("Default_Handler")));
void EEPROM_IRQHandler      (void) __attribute__ ((weak, alias("Default_Handler")));
void Reserved45_IRQHandler  (void) __attribute__ ((weak, alias("Default_Handler")));
void Reserved46_IRQHandler  (void) __attribute__ ((weak, alias("Default_Handler")));
void PIO0_IRQHandler        (void) __attribute__ ((weak, alias("Default_Handler")));


/*----------------------------------------------------------------------------
  Exception / Interrupt Vector table
 *----------------------------------------------------------------------------*/
extern const pFunc __Vectors[ 48];
       const pFunc __Vectors[ 48] __attribute__ ((section ("RESET"))) = {
  (pFunc)(&__initial_sp),                   /*     Initial Stack Pointer */
  Reset_Handler,                            /*     Reset Handler */
  NMI_Handler,                              /* -14 NMI Handler */
  HardFault_Handler,                        /* -13 Hard Fault Handler */
  0,                                        /*     Reserved */
  0,                                        /*     Reserved */
  0,                                        /*     Reserved */
  0,                                        /*     Checksum of the first 7 words */
  0,                                        /*     Reserved */
  0,                                        /*     Enhanced image marker, set to 0x0 for legacy boot */
  0,                                        /*     Pointer to enhanced boot block, set to 0x0 for legacy boot */
  SVC_Handler,                              /*  -5 SVCall Handler */
  0,                                        /*     Reserved */
  0,                                        /*     Reserved */
  PendSV_Handler,                           /*  -2 PendSV Handler */
  SysTick_Handler,                          /*  -1 SysTick Handler */

  /* Interrupts */
  PIO0_0_IRQHandler,                        /*     PIO0_0 Start Logic Interrupt */
  PIO0_1_IRQHandler,                        /*     PIO0_1 Start Logic Interrupt */
  PIO0_2_IRQHandler,                        /*     PIO0_2 Start Logic Interrupt */
  PIO0_3_IRQHandler,                        /*     PIO0_3 Start Logic Interrupt */
  PIO0_4_IRQHandler,                        /*     PIO0_4 Start Logic Interrupt */
  PIO0_5_IRQHandler,                        /*     PIO0_5 Start Logic Interrupt */
  PIO0_6_IRQHandler,                        /*     PIO0_6 Start Logic Interrupt */
  PIO0_7_IRQHandler,                        /*     PIO0_7 Start Logic Interrupt */
  PIO0_8_IRQHandler,                        /*     PIO0_8 Start Logic Interrupt */
  PIO0_9_IRQHandler,                        /*     PIO0_9 Start Logic Interrupt */
  PIO0_10_IRQHandler,                       /*     PIO0_10 Start Logic Interrupt */
  RFFIELD_IRQHandler,                       /*     NFC Access Start Logic Interrupt */
  RTCPWREQ_IRQHandler,                      /*     RTC Wakeup Request Start Logic Interrupt */
  NFC_IRQHandler,                           /*     NFC Read/Write Interrupt */
  RTC_IRQHandler,                           /*     RTC Wakeup Interrupt */
  I2C0_IRQHandler,                          /*     I2C0 Interrupt */
  CT16B0_IRQHandler,                        /*     16-bit Timer 0 Interrupt */
  PMUFLD_IRQHandler,                        /*     RF Power Detection Interrupt */
  CT32B0_IRQHandler,                        /*     32-bit Timer 0 Interrupt */
  PMUBOD_IRQHandler,                        /*     Brown Out Detection Interrupt */
  SSP0_IRQHandler,                          /*     SSP0 Interrupt */
  TSEN_IRQHandler,                          /*     Temperature Sensor Interrupt */
  C2D_IRQHandler,                           /*     Capacitance-to-Digital converter Interrupt */
  Reserved39_IRQHandler,                    /*     Reserved interrupt */
  I2D_IRQHandler,                           /*     Current-to-Digital converter Interrupt */
  ADCDAC_IRQHandler,                        /*     Analog-to-Digital/Digital-to-Analog converter Interrupt */
  WDT_IRQHandler,                           /*     Watchdog Timer Interrupt */
  FLASH_IRQHandler,                         /*     FLASH memory Interrupt */
  EEPROM_IRQHandler,                        /*     EEPROM memory Interrupt */
  Reserved45_IRQHandler,                    /*     Reserved interrupt */
  Reserved46_IRQHandler,                    /*     Reserved interrupt */
  PIO0_IRQHandler                           /*     GPIO Port 0 Interrupt */
};


/*----------------------------------------------------------------------------
  Reset Handler called on controller reset
 *----------------------------------------------------------------------------*/
void Reset_Handler(void) {

  SystemInit();                             /* CMSIS System Initialization */
  __main();                                 /* Enter PreeMain (C library entry point) */
}


/*----------------------------------------------------------------------------
  Default Handler for Exceptions / Interrupts
 *----------------------------------------------------------------------------*/
void Default_Handler(void) {

  while(1);
}
